module.exports = function(app, io, passport, Account, Character) {

/* GET views/users.hbs */
app.route('/users')
  .get(function(req, res) {
    Account.find(function(err, accounts){
      if(err) {
        res.send(err);
      } else {
        res.render('users/users', { 
          title: 'Users | Mumsy',
          users: accounts
        });
      }
    });
  });

/* GET views/user.hbs */
/* POST views/user.hbs */
app.route('/users/:user_id')
  .get(checkOwner, function(req, res) {
    Account.findOne({_id: req.params.user_id}, function(err, account){
      if(err) {
        res.send(err);
      } else {
        res.render('users/user', { 
          title: 'User Profile | Mumsy',
          profileUser: account
        });
      }
    });
  })
  .post(isOwner, function(req, res){
    Account.findById(req.params.user_id, function(err, account){
      if(err) {
        res.send(err);
      } else {
        // save the account
        account.username = req.body.username;
        account.email = req.body.email;
        account.save(function(err) {
            if(err){
              res.send(err);
            } else {
              res.render('users/user', { 
                title: 'User Profile | Mumsy',
                profileUser: account
              });            
            }
        });        
      }
    });    
  });  

/* GET views/edit_user.hbs */
app.get('/users/:user_id/edit', isOwner, function(req, res, next) {
    Account.findById(req.params.user_id, function(err, account){
      if(err) {
        res.send(err);
      } else {
        res.render('users/edit_user', { 
          title: 'Edit Profile | Mumsy',
          profileUser: account
        });             
      }
    });  
});

// route middleware to make sure a user is an admin
function isAdmin(req, res, next) {

    // if user is authenticated in the session, carry on 
    if (req.isAuthenticated()) {
      if (req.user.admin) {
        return next();
      } else {      
      req.flash('error', 'You need to be logged in and an admin to view this page.');        
        res.redirect('/');  
      }
    } else {
      req.flash('error', 'You need to be logged in and an admin to view this page.');       
      res.redirect('/');          
    }
}

// route middleware to make sure a user is an admin
function isOwner(req, res, next) {

    // if user is authenticated in the session, carry on 
    if (req.isAuthenticated()) {
      if (req.user._id == req.params.user_id) {
        res.locals.isOwner = true
        return next();
      } else {      
      req.flash('error', 'You need to be logged in and the proper to view this page.');        
        res.redirect('/');  
      }
    } else {
      req.flash('error', 'You need to be logged in and an admin to view this page.');       
      res.redirect('/');          
    }
}

// route middleware to make sure a user is an admin
function checkOwner(req, res, next) {

    // if user is authenticated in the session, carry on 
    if (req.isAuthenticated()) {
      if (req.user._id == req.params.user_id || req.user.admin == true) {
        res.locals.isOwner = true
        return next();
      } else {      
        return next();
      }  
    } else {
      return next();          
    }
}

};
